Attribute VB_Name = "ZAcq"
Option Explicit
Declare Function timeGetTime Lib "winmm.dll" () As Long

'Z-POSITION IN THE STACK INCREASES GOING DOWN
Global NumPlanes As Long
Global StepSize As Double
Global ZTop As Double, ZBot As Double
Global Const UNDEF = 77777
Global Const sErr = "Error"
Global FTool As Object
Global ZLog As String
Global ahndl As Long 'handle of capture application
Global CaptureProg As Integer 'Capture program
'0-UNDEFINED, 1-Canon EOS Utility, 2-Canon RemoteCapture, 3-Breeze DSLR Remote Pro, 4-Fuji Studio Utility, 100-Hardware trigger
Global CaptureDelay As Double 'IN SEC.
Global SettleDelay As Double 'IN SEC.
Global Period As Double 'IN SEC.
Global KeyDelay As Long 'IN MSEC.
Global TriggerHold As Long 'IN MSEC.
Global FujiKey As Long '1-space, 2-Enter
Global CancelFlag As Integer
Global CaptureProgPath As String
Global Const sPathFileName = "captureprogpath.txt"
Global CaptureKey As String
Global Const sKeyFileName = "capturekey.txt"


Function UpdateStepSize() As Integer
   If ((ZTop = UNDEF) Or (ZBot = UNDEF) Or (ZTop = ZBot) Or (NumPlanes <= 0)) Then
      UpdateStepSize = -1
   Else
      StepSize = Abs(ZBot - ZTop) / (NumPlanes - 1)
      UpdateStepSize = 1
   End If
End Function

Function UpdateNumPlanes() As Integer
   If ((ZTop = UNDEF) Or (ZBot = UNDEF) Or (ZTop = ZBot) Or (StepSize <= 0)) Then
      UpdateNumPlanes = -1
   Else
      NumPlanes = Abs(ZBot - ZTop) / StepSize + 1
      UpdateNumPlanes = 1
   End If
End Function

Function ReconcileParameters() As Integer
   Dim w As Double
   'ENSURE TOP IS ABOVE BOTTOM
   If ((ZTop = UNDEF) Or (ZBot = UNDEF) Or (ZTop = ZBot)) Then ReconcileParameters = -1: Exit Function
   If ((StepSize = UNDEF) Or (StepSize <= 0)) Then ReconcileParameters = -1: Exit Function
   If ((NumPlanes = UNDEF) Or (NumPlanes <= 0)) Then ReconcileParameters = -1: Exit Function
   If (ZTop > ZBot) Then
      w = ZTop: ZTop = ZBot: ZBot = w 'SWAP
      Call DisplayValues
   End If
   'DELAY
   On Error GoTo Err
   CaptureDelay = CDbl(frmZStackAcq.txtDelay.Text)
   SettleDelay = CDbl(frmZStackAcq.txtSettle.Text)
   Period = CDbl(frmZStackAcq.txtPeriod.Text)
   ReconcileParameters = 1
   Exit Function
Err:
   ReconcileParameters = -1
End Function

Sub DisplayValues()
   If (ZTop <> UNDEF) Then frmZStackAcq.lblTop.Caption = Format(ZTop, "0.00")
   If (ZBot <> UNDEF) Then frmZStackAcq.lblBot.Caption = Format(ZBot, "0.00")
   If (NumPlanes <> UNDEF) Then frmZStackAcq.txtNumPlanes = Format(NumPlanes, "0")
   If (StepSize <> UNDEF) Then frmZStackAcq.txtStepSize = Format(StepSize, "0.00")
   frmZStackAcq.lblMsg.Caption = "ZTop= " & Format(ZTop, "0.00") & ", ZBottom= " & Format(ZBot, "0.00") & ", ZHeight= " & Format(Abs(ZBot - ZTop), "0.00")
End Sub

Function AcquireZStack() As Integer
   Dim target As Double, stepcmd As String, i As Integer, spos As String, s As String
   Dim time0 As Long, deltat As Long, Pms As Long
   Static invok As Integer
   If (invok > 0) Then Exit Function
   invok = invok + 1
   'VERIFY DATA
   If (ReconcileParameters() < 0) Then
      frmZStackAcq.lblMsg.Caption = sErr: AcquireZStack = -1: GoTo ENDACQZ
   End If
   DoEvents
   CancelFlag = 0
   ZLog = "Planes " & Format(NumPlanes, "0") & ", Step = " & Format(-StepSize, "0.00") & " ;" & vbCrLf
   'MOVE TO BELOW THE BOTTOM OF Z STACK THEN STEP UP AND ACQUIRE
   target = ZBot + StepSize
   FTool.Exec ("Z " & Format(target, "0.0000") & " ; Z Wait ;")
   frmZStackAcq.lblMsg.Caption = "Z= " & Format(target, "0.00")
   stepcmd = "Z Rel " & Format(-StepSize, "0.0000") & " ; Z Wait ;"
   Pms = Fix(Period * 1000)
   For i = 1 To NumPlanes
      'RECORD START TIME
      time0 = timeGetTime
      'STEP, WAIT AND READ POSITION
      FTool.Exec (stepcmd)
      spos = FTool.Exec("Z ?")
      s = "#" & Format(i, "0") & ", Z=" & spos
      frmZStackAcq.lblMsg.Caption = s
      ZLog = ZLog & s & vbCrLf
      Call Delay(Fix(SettleDelay * 1000))
      DoEvents
      'ACQUIRE
      Call CaptureImage
      'CHECK IF NOT CANCELLED BY THE USER
      If (CancelFlag = 1) Then
         frmZStackAcq.lblMsg.Caption = "Z-stack cancelled"
         AcquireZStack = -1: GoTo ENDACQZ
      End If
      Call Delay(Fix(CaptureDelay * 1000))
      'CHECK FOR PERIOD
      If (Period > 0) Then
         deltat = timeGetTime - time0
         If (deltat > Pms) Then
            frmZStackAcq.lblMsg.Caption = "Given period is too short"
            DoEvents
         Else
            Call Delay(Pms - deltat)
         End If
      End If
   Next
   frmZStackAcq.lblMsg.Caption = "Z-stack finished"
   AcquireZStack = 1
ENDACQZ:
   invok = invok - 1
End Function

Function Give1stWord(str0 As String, wrd As String) As Integer
   'FORMS FIRST WORD OF str0 IN wrd AND REMAINDER OF str0 IN str0
   'RETURNS LENGTH OF THE FIRST WORD. 0 - NO WORD
   Dim s As String, bpos As Long
   s = Trim(str0) & " "
   bpos = InStr(s, " ") - 1
   wrd = Left$(s, bpos)
   str0 = Trim(Right$(s, Len(s) - bpos))
   Give1stWord = bpos
End Function

Function CaptureImage() As Integer
   Dim whndl As Long
   If (ahndl = 0) Then Exit Function
   'HANDLE HARDWARE TRIGGER
   If (CaptureProg = 100) Then
      FTool.Exec ("CON /2J1R"): Delay (TriggerHold): FTool.Exec ("CON /2J0R"):
      Exit Function
   End If
   'HANDLE SOFTWARE CAPTURE
   AppActivate ahndl
   Call Delay(KeyDelay)
   Select Case (CaptureProg)
      Case 1: SendKeys " ", True 'Canon EOS Utility
      Case 2: SendKeys " ", True 'Canon Remote capture
      Case 3: SendKeys "{F8}", True 'Breeze DSLR Remote Pro
      Case 4: 'Fuji Studio Utility
               If (FujiKey = 1) Then
                  SendKeys " ", True
               ElseIf (FujiKey = 2) Then
                  SendKeys "{ENTER}", True
               End If
      Case 5: SendKeys CaptureKey, True 'Custom path and key
   End Select
End Function

Function LaunchCapture() As Long
   Dim s As String
   frmZStackAcq.lblMsg.Caption = ""
   DoEvents
   On Error GoTo BadLaunch
   Select Case (CaptureProg)
      Case 1: ahndl = Shell("C:\Program Files\Canon\EOS Utility\EOS Utility.exe", vbNormalFocus)
      Case 2: ahndl = Shell("C:\Program Files\Canon\RemoteCapture\RemoteCapture.exe", vbNormalFocus)
      Case 3: ahndl = Shell("C:\Program Files\BreezeSys\DSLR Remote Pro\DSlrRemote.exe", vbNormalFocus)
      Case 4: ahndl = Shell("C:\Program Files\HyperUtility\StudioUtility.exe", vbNormalFocus)
      Case 5: ahndl = Shell(CaptureProgPath, vbNormalFocus)
      Case 100: s = FTool.Exec("CON /2&")
               If (InStr(s, "EZStepper")) Then
                  ahndl = 1: frmZStackAcq.lblMsg.Caption = s
               Else
                  ahndl = 0: frmZStackAcq.lblMsg.Caption = "EZStepper does not respond"
               End If
   End Select
   LaunchCapture = ahndl
   Exit Function
BadLaunch:
   frmZStackAcq.lblMsg.Caption = "Error Launching Capture Program"
End Function

Sub ReadCaptureprogpath()
   Dim nextstr As String, file As Integer, sP As String
   sP = App.Path & "\" & sPathFileName
   If (Len(Dir$(sP)) <= 0) Then
      frmZStackAcq.lblMsg.Caption = "File " & sPathFileName & " does not exist"
      frmZStackAcq.cmdLaunchCapture.Enabled = False
      Exit Sub
   End If
   file = FreeFile
   Open sP For Input As #file
   CaptureProgPath = ""
   Do While Not EOF(1)
      Input #file, nextstr
      CaptureProgPath = Trim$(nextstr)
   Loop
   Close #file
   If (Len(CaptureProgPath) > 0) Then
      frmZStackAcq.lblMsg.Caption = CaptureProgPath
      Exit Sub
   End If
   frmZStackAcq.lblMsg.Caption = "File " & sPathFileName & " is empty"
   frmZStackAcq.cmdLaunchCapture.Enabled = False
End Sub
Sub ReadCapturekey()
   Dim nextstr As String, file As Integer, sK As String
   sK = App.Path & "\" & sKeyFileName
   If (Len(Dir$(sK)) <= 0) Then
      frmZStackAcq.lblMsg.Caption = "File " & sKeyFileName & " does not exist"
      frmZStackAcq.cmdLaunchCapture.Enabled = False
      Exit Sub
   End If
   file = FreeFile
   Open sK For Input As #file
   CaptureKey = ""
   Do While Not EOF(1)
      Input #file, nextstr
      CaptureKey = Replace(Trim$(nextstr), "{SPACE}", " ")
   Loop
   Close #file
   If (Len(CaptureKey) > 0) Then
      frmZStackAcq.lblMsg.Caption = frmZStackAcq.lblMsg.Caption & " Key <" & CaptureKey & ">"
      Exit Sub
   End If
   frmZStackAcq.lblMsg.Caption = "File " & sKeyFileName & " is empty"
   frmZStackAcq.cmdLaunchCapture.Enabled = False
End Sub
